
#include "iodefine.h"
#include "ecu_init.h"
#include "iscv.h"

unsigned char ISCVSTEP;

void set_iscv(unsigned char a)	//  f[eB 0-100 lƉ]オ
{
	unsigned int temp;

	if(a>ISCVMAX) a=ISCVMAX;	// ͈͂̃`FbN
	if(a<ISCVMIN) a=ISCVMIN;	// fB[eB[ ʓdԂ45`78%
	
	ISCVSTEP=a;
	temp=MTU23.TGRB;
	temp=temp*a/100;
	MTU23.TGRA=temp;
}

// 1ÂJEgl𑝌
/*
void idl_control(signed int a)
{
	signed int temp;
	unsigned int min,max;
	
	min=MTU23.TGRB*ISCVMIN/100;
	max=MTU23.TGRB*ISCVMAX/100;

	temp=MTU23.TGRA+a;
	if(temp>max) temp=max;
	if(temp<min) temp=min;
	MTU23.TGRA=temp;
	ISCVSTEP=temp*100/MTU23.TGRB;

	// TEN[qLoieXg[hjISCVl
	if(IN_TEN==0) set_iscv(ISCVDEF);
}
*/

// 0.1%Â
void idl_control(signed char a)
{
	signed int temp;
	unsigned int min,max;
	
	min=MTU23.TGRB*ISCVMIN/100;
	max=MTU23.TGRB*ISCVMAX/100;

	temp=(signed int)a*MTU23.TGRB/1000;

	temp+=MTU23.TGRA;

	if(temp>max) temp=max;
	if(temp<min) temp=min;
	MTU23.TGRA=temp;
	ISCVSTEP=temp*100/MTU23.TGRB;

	// TEN[qLoieXg[hjISCVl
	if(IN_TEN==0) set_iscv(ISCVDEF);
}

void iscv_init(void)
{
	PFC.PEIORL.BIT.B8=1;	// TIOC3A ͏o
	PFC.PECRL3.BIT.PE8MD=1;	// PE6TIOC2A;
	
	STB.CR4.BIT._MTU2=0;	// W[Xgbv[h
	MTU2.TSTR.BIT.CST3=0;	// ^C}[~
	MTU23.TCR.BIT.CCLR=2;	// TGRB ̃RyA}b`TCNT NA
	MTU23.TCR.BIT.TPSC=1;	// ̓NbNI /4
	MTU23.TIOR.BIT.IOA=5;	// TIOC3A o͂1 RyA}b`0o
	MTU23.TIOR.BIT.IOB=6;	// TIOC3B o͂1 RyA}b`1o
	MTU23.TMDR.BYTE=2;		// PWM[h1
	
	//  6.2ms
	// 0.0062[s]/(1/IOCLK*4)
	// 0.0062*(IOCLK/4) 37200
	// 62*(IOCLK/4)/10000
	// 62*(IOCLK/10000/4)
	
	MTU23.TGRB=62*(IOCLK/10000/4);
	set_iscv(90);
	
	MTU2.TSTR.BIT.CST3=1;	// ^C}[X^[g
}
